#import "MyController.h"
// Beispiel Schrittmotor
// 31. Mai 2005 Version 1.0



@implementation MyController

// Setzt den Timer des Betriebssystems
// die Routine (void) timerAusgeloest wird dann im definierten Zeitintervall [ms] aufgerufen 
- (void) startTimer:(float) Zeitintervall
{
  if (!timer ){						// Timer noch nicht aktiv
    timer = [[NSTimer	scheduledTimerWithTimeInterval:Zeitintervall
                            target:self
                            selector:@selector(timerAusgeloest:)
                            userInfo:nil
                            repeats:YES]retain];
  }
  else {									// timer schon aktiv. Erst stoppen, dann nochmal starten
    [timer invalidate];
    [timer release];
    timer = [[NSTimer	scheduledTimerWithTimeInterval:Zeitintervall
                            target:self
                            selector:@selector(timerAusgeloest:)
                            userInfo:nil
                            repeats:YES] retain];
  }
}

// Hlt den Timer an.
- (void) stopTimer
{
  if (timer){
    [timer invalidate];
    [timer release];
    timer = nil;
  }
}


// Wenn der Timer gesetzt ist, wird diese Routine turnusmig ausgefhrt
// Setzt den nchsten Voll- oder Halbschritt
- (void) timerAusgeloest:(void *) dummy
{
	// Ausgnge setzen
	ServiceUSB_SetOutputValueByMask(SchrittAusgabeWert[AktuellerSchritt],(ServiceUSB_DeviceIdentifierRef) 0,kServiceUSB_DefaultTimeout);
	
	// Nchsten Schritt berechnen (Voll,Halb, Vor- oder Rckwrts)
	if (Halbschritt){
		if (aktuelleDrehrichtung){
			AktuellerSchritt++;
			if (AktuellerSchritt > 7)
				AktuellerSchritt = 0;
		}
		else{
			AktuellerSchritt--;
			if (AktuellerSchritt < 0)
				AktuellerSchritt = 7;
		}
	}
	else{
		if (aktuelleDrehrichtung){
			AktuellerSchritt+=2;
			if (AktuellerSchritt > 7)
				AktuellerSchritt = 0;
		}
		else{
			AktuellerSchritt-=2;
			if (AktuellerSchritt < 0)
				AktuellerSchritt = 6;
		}
	}		
	
	// Wenn dauerdrehen, Schrittanzahl nicht bercksichtigen,
	// sonst Schrittanzahl um eins herunterzhlen
	if (!Dauerdrehen){				
		if (--Schrittanzahl <= 0){
			[self stopTimer];
			if (Halten == 0) // Alle Schritte ausgefhrt. Motor nicht unter Strom halten
					ServiceUSB_SetOutputValueByMask("XXXX0000",(ServiceUSB_DeviceIdentifierRef) 0,kServiceUSB_DefaultTimeout);
		}
	}	
}

// Ankreuzfeld fr Dauerdrehen, Halbschritt und letzten Schritt halten wurde gendert
- (IBAction)Bitfeldaenderung:(id)sender
{
	if (Dauerdrehen == 0 && [[sender cellWithTag:0]state] == 1){// Dauerdrehen wurde angekreuzt
		Dauerdrehen = [[sender cellWithTag:0]state];							// Dauerdrehen starten
		[self Drehen:self];
	}
	if (Dauerdrehen == 1 && [[sender cellWithTag:0]state] == 0){// Dauerdrehen wurde ausgekreuzt
		Dauerdrehen = [[sender cellWithTag:0]state];							// Dauerdrehen stoppen
		[self stopTimer];
	}	
	
	if (Halbschritt == 0 && [[sender cellWithTag:1]state] == 1){// Halbschritt wurde angekreuzt	
		Halbschritt = 1;	
		if (Dauerdrehen == 1 || Schrittanzahl > 0)
			[self Drehen:self];
	}
	
	if (Halbschritt == 1 && [[sender cellWithTag:1]state] == 0){ // Halbschritt wurde ausgekreuzt
		Halbschritt = 0;
		AktuellerSchritt = AktuellerSchritt/2;
		AktuellerSchritt = AktuellerSchritt*2;
		if (Dauerdrehen == 1 || Schrittanzahl > 0)
			[self Drehen:self];
	}
				
	Halten = [[sender cellWithTag:2]state];
	if (Halten == 0 && (Schrittanzahl == 0 || Dauerdrehen == 0))
		ServiceUSB_SetOutputValueByMask("XXXX0000",(ServiceUSB_DeviceIdentifierRef) 0,kServiceUSB_DefaultTimeout);
}

// Knopf drehen wurde gedrckt
// Wird aber auch aus anderen Stellen im Programm aufgerufen
- (IBAction)Drehen:(id)sender
{
	float U_pro_min;
	float interruptZeit;
	float Schrittwinkel;
	static int Schritte;
	
	// Berechnung der Interrupt-Zeit fr den Timer.
	U_pro_min = [[Textfeld cellAtRow:1 column:0] floatValue];
	Schrittwinkel = [[Textfeld cellAtRow:2 column:0] floatValue];
	if (Halbschritt) Schrittwinkel /=2;
	interruptZeit = 1/((360.0/Schrittwinkel)*(U_pro_min/60.0));
	
	// Wenn Dauerdrehen nicht angekreutzt, wird eine begrenzte Anzahl Schritte ausgefhrt
	if (Dauerdrehen == 0)
		Schrittanzahl = [[Textfeld cellAtRow:0 column:0] intValue];
		
	// und drehen .....	
	[self startTimer:	(interruptZeit/2.0)];
	
}

// Rechts Links Drehrichtung Radio-Button wurde bettigt
- (IBAction)Drehrichtungsaenderung:(id)sender
{
	aktuelleDrehrichtung = [[sender selectedCell]tag];
}

- (IBAction)Notaus:(id)sender
{
	[self stopTimer];
	ServiceUSB_SetOutputValueByMask("XXXX0000",(ServiceUSB_DeviceIdentifierRef) 0,kServiceUSB_DefaultTimeout);	
	[[Bitfeld cellWithTag:0] setIntValue:0];
	Dauerdrehen = 0;
}

// Die Betriebsparameter in den Textfeldern (U/min, Schrittanzahl, Winkel) wurde gendert
- (IBAction)Textaenderung:(id)sender
{
	if (Dauerdrehen == 1 || Schrittanzahl > 0)
	[self Drehen:self];
}

// Initialisierung
- (void) awakeFromNib
{
	memcpy(SchrittAusgabeWert[0],"XXXX0010",8);
	memcpy(SchrittAusgabeWert[1],"XXXX0110",8);
	memcpy(SchrittAusgabeWert[2],"XXXX0100",8);
	memcpy(SchrittAusgabeWert[3],"XXXX0101",8);
	memcpy(SchrittAusgabeWert[4],"XXXX0001",8);
	memcpy(SchrittAusgabeWert[5],"XXXX1001",8);
	memcpy(SchrittAusgabeWert[6],"XXXX1000",8);
	memcpy(SchrittAusgabeWert[7],"XXXX1010",8);
	AktuellerSchritt = 0;
	Halbschritt=NO;
	Schrittanzahl = 0;
	aktuelleDrehrichtung = 1;//1=Links, 0=Rechts
	Dauerdrehen = NO;
	Halten = NO;
}

// Progamm beendet sich. Motor Stromlos schalten, Timer aus
- (NSApplicationTerminateReply) applicationShouldTerminate:(NSApplication *)sender
{
	ServiceUSB_SetOutputValueByMask("XXXX0000",(ServiceUSB_DeviceIdentifierRef) 0,kServiceUSB_DefaultTimeout);
	[self stopTimer];
	return YES;
}
@end
